      PROGRAM TDE53D3
      DOUBLE PRECISION YN,Y,RAB,YT,DELY(2),
     1                 XN,H,XK,H0,Q
      DIMENSION YN(2),Y(2),RAB(446),YT(2)
      DOUBLE PRECISION R(16,2),DELTR(16,2)
      INTEGER S
      COMMON/DELTR/R,DELTR,NI
      EXTERNAL F,FTREAT
      NI=16
      M=2
      Q=0.5D0
      XN=0.
      YN(1)= COS(Q)+1.D0
      YN(2)=-SIN(Q)+1.D0
      XK=1.D0
      H0=0.5D0
      YT(1)=COS(Q*(2.D0*XK-1.D0))+1.D0
      YT(2)=SIN(Q*(2.D0*XK-1.D0))+1.D0
      K=11
      IMAX=13
      DO 42 INIAP0=1,2
      INIAPR=INIAP0
      H=H0
      CALL DE53D(F,FTREAT,M,XN,YN,XK,K,INIAPR,IMAX,H,Y,
     1           RAB)
      DELY(1)=YT(1)-Y(1)
      DELY(2)=YT(2)-Y(2)
      PRINT 47
      PRINT 35, H0,K,INIAPR,IMAX
      PRINT 60, Y,YT,DELY
      PRINT 47
C
C_____________________________
C
      DO 10 S=1,2
      PRINT 150,S
      PRINT 70, (J,R(J,S),DELTR(J,S),J=1,NI)
      PRINT 49
   10 CONTINUE
      PRINT 48
C
C_____________________________
C
   42 CONTINUE
      STOP
   47 FORMAT( 1X,64(1H-)/)
   48 FORMAT(/1X,64(1H*)/) 
   49 FORMAT(/)  
   35 FORMAT(/1X,'H0=',D25.16,3X,'K=',I2,3X,'INIAPR=',I1,3X,'IMAX=',I2)
   60 FORMAT(1X,'Y =',2D25.16/1X,'YT=',2D25.16/1X,'DELTA Y  =',2D25.16)
   70 FORMAT(5X,I2,5X,2D25.16)
  150 FORMAT('   Number of',7X,' Phase motion '
     *       ' for ',I1,' segment'/  
     1        14X,51(1H-)/
     2       '    point',14X,'distance',17X,'error'/         
     3        1X,64(1H-)/)
      END

      SUBROUTINE F(X,Y,Z,M)
      DOUBLE PRECISION X,Y(2),Z(2),R,Q
      Q=0.5D0
      R =2.D0*X-1.D0
      Z(1)=-2.D0*Q*(Y(2)-1.D0)+(1.D0-DEXP(1.D0-Y(1)+DCOS(Q*R)))/(1.D0+X) 
      Z(2)= 2.D0*Q*(Y(1)-1.D0)+(1.D0-DEXP(1.D0-Y(2)+DSIN(Q*R)))/(1.D0+X) 
      RETURN
      END


      SUBROUTINE FTREAT(S,XI,XE,Y,AY,ADY,M,KP1,KP2)
      INTEGER S,M,KP1,KP2
      DOUBLE PRECISION XI,XE,Y,AY,ADY
      DIMENSION AY(M,KP2),ADY(M,KP1)
      DOUBLE PRECISION YI(2),R(16,2),DELTR(16,2),HI,X,BK(2,2)
      COMMON/DELTR/R,DELTR,NI
      HI=(XE-XI)/DBLE(NI)
      X=XI
      DO 10 J=1,NI
      X=X+HI      
C
C------CALCULATION OF SOLUTION YI AT POINT X (BY ALGORITHM CLENSHAW)
C
      CALL DE70DC(M,KP1,X,AY,YI,BK)
C
      R(J,S)=SQRT((YI(1)-1.D0)**2+(YI(2)-1.D0)**2)
      DELTR(J,S)=1.D0-R(J,S)
   10 CONTINUE
      RETURN
      END
            